/*  ga_command_signals.c */
/* 	Copyright 2004-2005 Oswaldo Morizaki Hirakata */

/* 	This file is part of ga-nn-ag.

    ga-nn-ag is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn-ag is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn-ag; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "my_header.h"
#include "aux_prot.h"

void ga_command_sig_chld(int signo, siginfo_t * siginfo, void * ucontext)
{
	pid_t pid;
	int status;
	int value;
	
	waitpid(siginfo->si_pid, &status, 0);
	
	if (WIFEXITED(status)) //Normally terminated
	{
		if ((value = WEXITSTATUS(status)) == 0)
		{
			syslog(LOG_INFO,"Child normally terminated pid=%d",siginfo->si_pid);		
		}
		else
		{	
			syslog(LOG_ERR,"Child exited with error pid=%d status=%d",siginfo->si_pid,value);
		}
	}
	
	return;
}

